GEOS: geos::planargraph::PlanarGraph Class Reference

Public Types | Public Member Functions | Protected Member Functions | Protected Attributes

# geos::planargraph::PlanarGraph Class Reference

Represents a directed graph which is embeddable in a planar surface. More...

`#include <geos/planargraph.h>`

Inheritance diagram for geos::planargraph::PlanarGraph:

List of all members.

## Public Types
typedef std::vector< Edge * > | EdgeContainer
typedef EdgeContainer::iterator | EdgeIterator
## Public Member Functions
| PlanarGraph ()
| Constructs a PlanarGraph without any Edges, DirectedEdges, or Nodes.
Node * | findNode (const geom::Coordinate &pt)
| Returns the Node at the given location, or null if no Node was there.
NodeMap::container::iterator | nodeIterator ()
| Returns an Iterator over the Nodes in this PlanarGraph.
NodeMap::container::iterator | nodeBegin ()
NodeMap::container::const_iterator | nodeBegin () const
NodeMap::container::iterator | nodeEnd ()
NodeMap::container::const_iterator | nodeEnd () const
void | getNodes (std::vector< Node * > &nodes)
| Returns the Nodes in this PlanarGraph.
std::vector< DirectedEdge * > ::iterator | dirEdgeIterator ()
| Returns an Iterator over the DirectedEdges in this PlanarGraph, in the order in which they were added.
std::vector< Edge * >::iterator | edgeIterator ()
| Alias for edgeBegin()
std::vector< Edge * >::iterator | edgeBegin ()
| Returns an iterator to first Edge in this graph.
std::vector< Edge * >::iterator | edgeEnd ()
| Returns an iterator to one-past last Edge in this graph.
std::vector< Edge * > * | getEdges ()
| Returns the Edges that have been added to this PlanarGraph.
void | remove (Edge *edge)
| Removes an Edge and its associated DirectedEdges from their from-Nodes and from this PlanarGraph.
void | remove (DirectedEdge *de)
| Removes DirectedEdge from its from-Node and from this PlanarGraph.
void | remove (Node *node)
| Removes a node from the graph, along with any associated DirectedEdges and Edges.
std::vector< Node * > * | findNodesOfDegree (std::size_t degree)
| Returns all Nodes with the given number of Edges around it. The return value is a newly allocated vector of existing nodes.
void | findNodesOfDegree (std::size_t degree, std::vector< Node * > &to)
| Get all Nodes with the given number of Edges around it.
## Protected Member Functions
void | add (Node *node)
| Adds a node to the std::map, replacing any that is already at that location.
void | add (Edge *edge)
| Adds the Edge and its DirectedEdges with this PlanarGraph.
void | add (DirectedEdge *dirEdge)
| Adds the Edge to this PlanarGraph.
## Protected Attributes
std::vector< Edge * > | edges
std::vector< DirectedEdge * > | dirEdges
NodeMap | nodeMap

## Detailed Description

Represents a directed graph which is embeddable in a planar surface.

This class and the other classes in this package serve as a framework for building planar graphs for specific algorithms. This class must be subclassed to expose appropriate methods to construct the graph. This allows controlling the types of graph components (DirectedEdge, Edge and Node) which can be added to the graph. An application which uses the graph framework will almost always provide subclasses for one or more graph components, which hold application-specific data and graph algorithms.

## Member Function Documentation

void geos::planargraph::PlanarGraph::add | ( | Node * | node ) | `[inline, protected]`

Adds a node to the std::map, replacing any that is already at that location.

Only subclasses can add Nodes, to ensure Nodes are of the right type.

Returns:
  the added node

void geos::planargraph::PlanarGraph::add | ( | Edge * | edge ) | `[protected]`

Adds the Edge and its DirectedEdges with this PlanarGraph.

Assumes that the Edge has already been created with its associated DirectEdges. Only subclasses can add Edges, to ensure the edges added are of the right class.

void geos::planargraph::PlanarGraph::add | ( | DirectedEdge * | dirEdge ) | `[inline, protected]`

Adds the Edge to this PlanarGraph.

Only subclasses can add DirectedEdges, to ensure the edges added are of the right class.

std::vector<DirectedEdge*>::iterator geos::planargraph::PlanarGraph::dirEdgeIterator | ( | ) | `[inline]`

Returns an Iterator over the DirectedEdges in this PlanarGraph, in the order in which they were added.

See also:
  add(Edge)
  add(DirectedEdge)

std::vector<Edge*>::iterator geos::planargraph::PlanarGraph::edgeBegin | ( | ) | `[inline]`

Returns an iterator to first Edge in this graph.

Edges are stored in the order they were added.

See also:
  add(Edge)

std::vector<Edge*>::iterator geos::planargraph::PlanarGraph::edgeEnd | ( | ) | `[inline]`

Returns an iterator to one-past last Edge in this graph.

Edges are stored in the order they were added.

See also:
  add(Edge)

void geos::planargraph::PlanarGraph::findNodesOfDegree | ( | std::size_t | degree,
|  | std::vector< Node * > & | to
| ) |  |

Get all Nodes with the given number of Edges around it.

Found nodes are pushed to the given vector

std::vector<Edge*>* geos::planargraph::PlanarGraph::getEdges | ( | ) | `[inline]`

Returns the Edges that have been added to this PlanarGraph.

See also:
  add(Edge)

void geos::planargraph::PlanarGraph::getNodes | ( | std::vector< Node * > & | nodes ) | `[inline]`

Returns the Nodes in this PlanarGraph.

Parameters:

  nodes | : the nodes are push_back'ed here

void geos::planargraph::PlanarGraph::remove | ( | Edge * | edge ) |

Removes an Edge and its associated DirectedEdges from their from-Nodes and from this PlanarGraph.

Note: This method does not remove the Nodes associated with the Edge, even if the removal of the Edge reduces the degree of a Node to zero.

void geos::planargraph::PlanarGraph::remove | ( | DirectedEdge * | de ) |

Removes DirectedEdge from its from-Node and from this PlanarGraph.

Note: This method does not remove the Nodes associated with the DirectedEdge, even if the removal of the DirectedEdge reduces the degree of a Node to zero.

The documentation for this class was generated from the following file:

- planargraph/PlanarGraph.h